#include <iostream.h>
#include "include.h"
#include "newran.h"
#include "tryrand.h"
#include <unistd.h>
#include <stdio.h>
#include <math.h>
#include <sys/time.h>
#define FIRST 99999
int getopt(int argc, char * const argv[], const char *optstring); 

extern char *optarg;
extern int optind, opterr, optopt;
int total = 0;

               
void generate_next_node(int i, double wait);
void generate_next_edge(int i, int j, double wait);
void set_init(int);
void prologue();
void epilogue();
void create_and_print_node(int,double);
void create_input_edge(int src,int dest, char *kind, char *pred);
void create_edge_plain(int src,int dest, char *kind, char *pred);
main(int argc, char *argv[]){
        int option;
        int mean=-1, sd = -1;
        struct timeval tv;
        double seed = 0.0;
        bool normal = false, poisson  = false;
        int count = 100; /* default */
        double *wait_list;
        Normal *NormalRV;
        SumRandom *IntArriv;


        while ((option=getopt(argc,argv,"n:p:c:"))!= -1){
                switch(option){
                        case 'n':
                                sscanf(optarg,"%d",&mean);
                                sd=mean/4; // 25%
                                normal = true;
                                break;
                        case 'p':
                                sscanf(optarg,"%d",&mean);
                                poisson = true;
                                break;
                        case 'c':
                                sscanf(optarg,"%d",&count);
                                break;
                        case '?': exit(1);
                }

        } 

        wait_list = (double*) calloc(count,sizeof(double));
        NormalRV = new Normal;
        IntArriv = new SumRandom( (double)sd * (*NormalRV) + (double)mean );
        gettimeofday(&tv,NULL);
        seed = 0.49 * sin(tv.tv_usec) + 0.50;    //  0.01 <= seed <= 0.99

        IntArriv->Set(seed);

        int i;
        for (i=0;i<count; ++i){
                fprintf(stdout,"%lu\n",(long unsigned int)IntArriv->Next());
        }
}
